



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>raft如何实现Linearizable Read</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">raft如何实现Linearizable Read</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-01 19:28:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Linearizable Read通俗来讲，就是读请求需要读到最新的已经commit的数据，不会读到老数据。</p>
<p>对于使用raft协议来保证多副本强一致的系统中，读写请求都可以通过走一次raft协议来满足。然后，现实系统中，读请求通常会占很大比重，如果每次读请求都要走一次raft落盘，性能可想而知。所以优化读性能至关重要。</p>
<p>从raft协议可知，leader拥有最新的状态，如果读请求都走leader，那么leader可以直接返回结果给客户端。然而，在出现网络分区和时钟快慢相差比较大的情况下，这有可能会返回老的数据，即stale read，这违反了Linearizable Read。例如，leader和其他followers之间出现网络分区，其他followers已经选出了新的leader，并且新的leader已经commit了一堆数据，然而由于不同机器的时钟走的快慢不一，原来的leader可能并没有发觉自己的lease过期，仍然认为自己还是合法的leader直接给客户端返回结果，从而导致了stale read。</p>
<p>Raft作者提出了一种叫做ReadIndex的方案：</p>
<p>当leader接收到读请求时，将当前commit index记录下来，记作read index，在返回结果给客户端之前，leader需要先确定自己到底还是不是真的leader，确定的方法就是给其他所有peers发送一次心跳，如果收到了多数派的响应，说明至少这个读请求到达这个节点时，这个节点仍然是leader，这时只需要等到commit index被apply到状态机后，即可返回结果。</p>
<pre class="prettyprint linenums"><code>func (n *node) ReadIndex(ctx context.Context, rctx []byte) error {<br />
	return n.step(ctx, pb.Message{Type: pb.MsgReadIndex, Entries: []pb.Entry{{Data: rctx}}})<br />
}

</code></pre>
<p>处理读请求时，应用的goroutine会调用这个函数，其中rctx参数相当于读请求id，全局保证唯一。step会往recvc中塞进一个MsgReadIndex消息，而运行node入口函数</p>
<pre class="prettyprint linenums"><code>func (n *node) run(r *raft)<br />
</code></pre>
<p>的goroutine会从recvc中拿出这个message，并进行处理：</p>
<pre class="prettyprint linenums"><code>case m := &lt;-n.recvc:<br />
			// filter out response message from unknown From.<br />
			if _, ok := r.prs[m.From]; ok || !IsResponseMsg(m.Type) {<br />
				r.Step(m) // raft never returns an error<br />
			}<br />
</code></pre>
<p>Step(m)最终会调用到raft结构体的step(m)，step是个函数指针，根据node的角色，运行stepLeader()/stepFollower()/stepCandidate()。</p>
<ul><li>如果node是leader，stepLeader()主要代码片段:</li></ul>
<pre class="prettyprint linenums"><code>	case pb.MsgReadIndex:<br />
	    if r.raftLog.zeroTermOnErrCompacted(r.raftLog.term(r.raftLog.committed)) != r.Term {<br />
                // Reject read only request when this leader has not committed any log entry at its term.<br />
                return<br />
        }

		if r.quorum() &gt; 1 {<br />
			switch r.readOnly.option {<br />
			case ReadOnlySafe:<br />
				r.readOnly.addRequest(r.raftLog.committed, m)<br />
				r.bcastHeartbeatWithCtx(m.Entries[0].Data)<br />
			case ReadOnlyLeaseBased:<br />
				var ri uint64<br />
				if r.checkQuorum {<br />
					ri = r.raftLog.committed<br />
				}<br />
				if m.From == None || m.From == r.id { // from local member<br />
					r.readStates = append(r.readStates, ReadState{Index: r.raftLog.committed, RequestCtx: m.Entries[0].Data})<br />
				} else {<br />
					r.send(pb.Message{To: m.From, Type: pb.MsgReadIndexResp, Index: ri, Entries: m.Entries})<br />
				}<br />
			}<br />
		}<br />
</code></pre>
<p>首先，r.raftLog.zeroTermOnErrCompacted需要检查leader是否在当前term有过commit entry，小论文5.4节关于Safety中给出了解释，以及不这么做会有什么问题，并且给出了反例。</p>
<p>其次，本文讨论的ReadIndex方案对应的是ReadOnlySafe这个option分支，其中addRequest(...)会把这个读请求到达时的commit index保存起来，并且维护一些状态信息，而bcastHeartbeatWithCtx(...)准备好需要发送给peers的心跳消息MsgHeartbeat。当node收到心跳响应消息MsgHeartbeatResp时处理如下:</p>
<p>只保留逻辑相关代码：</p>
<pre class="prettyprint linenums"><code>case pb.MsgHeartbeatResp:

		if r.readOnly.option != ReadOnlySafe || len(m.Context) == 0 {<br />
			return<br />
		}

		ackCount := r.readOnly.recvAck(m)<br />
		if ackCount &lt; r.quorum() {<br />
			return<br />
		}

		rss := r.readOnly.advance(m)<br />
		for _, rs := range rss {<br />
			req := rs.req<br />
			if req.From == None || req.From == r.id { // from local member<br />
				r.readStates = append(r.readStates, ReadState{Index: rs.index, RequestCtx: req.Entries[0].Data})<br />
			} else {<br />
				r.send(pb.Message{To: req.From, Type: pb.MsgReadIndexResp, Index: rs.index, Entries: req.Entries})<br />
			}<br />
		}<br />
</code></pre>
<p>首先只有ReadOnlySafe这个方案时，才会继续往下走。如果接收到了多数派的心跳响应，则会从刚才保存的信息中将对应读请求当时的commit index和请求id拿出来，填充到ReadState中，ReadState结构如下:</p>
<pre class="prettyprint linenums"><code>type ReadState struct {<br />
	Index      uint64<br />
	RequestCtx []byte<br />
}<br />
</code></pre>
<p>可以看出ReadState实际上包含了一个读请求到达node时，当前raft的状态commit index和请求id。</p>
<p>然后将ReadState append到raft结构体中的readStates数组中，readStates数组会被包含在Ready结构体中从readyc中pop出来供应用使用。</p>
<p>看看etcdserver是怎么使用的:</p>
<p>首先，在消费Ready的goroutine中：</p>
<pre class="prettyprint linenums"><code>if len(rd.ReadStates) != 0 {<br />
					select {<br />
					case r.readStateC &lt;- rd.ReadStates[len(rd.ReadStates)-1]:<br />
					case &lt;-time.After(internalTimeout):<br />
						plog.Warningf(&quot;timed out sending read state&quot;)<br />
					case &lt;-r.stopped:<br />
						return<br />
					}<br />
				}<br />
</code></pre>
<p>这里重点是把Ready中的ReadState放入readStateC中,readStateC是一个buffer大小为1的channel</p>
<p>然后，在etcdserver跑linearizableReadLoop()的另外一个goroutine中:</p>
<pre class="prettyprint linenums"><code>// 执行ReadIndex，ctx是request id<br />
if err := s.r.ReadIndex(cctx, ctx); err != nil {<br />
			cancel()<br />
			if err == raft.ErrStopped {<br />
				return<br />
			}<br />
			plog.Errorf(&quot;failed to get read index from raft: %v&quot;, err)<br />
			nr.notify(err)<br />
			continue<br />
}

//等待request id对应的ReadState从readStateC中pop出来<br />
for !timeout &amp;&amp; !done {<br />
			select {<br />
			case rs = &lt;-s.r.readStateC:<br />
				done = bytes.Equal(rs.RequestCtx, ctx)<br />
				if !done {<br />
					// a previous request might time out. now we should ignore the response of it and<br />
					// continue waiting for the response of the current requests.<br />
					plog.Warningf(&quot;ignored out-of-date read index response (want %v, got %v)&quot;, rs.RequestCtx, ctx)<br />
				}<br />
			case &lt;-time.After(s.Cfg.ReqTimeout()):<br />
				plog.Warningf(&quot;timed out waiting for read index response&quot;)<br />
				nr.notify(ErrTimeout)<br />
				timeout = true<br />
			case &lt;-s.stopping:<br />
				return<br />
			}<br />
}

if !done {<br />
			continue<br />
		}

		// 等待当前apply index大于等于commit index<br />
		if ai := s.getAppliedIndex(); ai &lt; rs.Index {<br />
			select {<br />
			case &lt;-s.applyWait.Wait(rs.Index):<br />
			case &lt;-s.stopping:<br />
				return<br />
			}<br />
}

</code></pre>
<p>至此，ReadIndex流程结束，总结一下，就四步:</p>
<ol><li>leader check自己是否在当前term commit过entry</li>
<li>leader记录下当前commit index，然后leader给所有peers发心跳广播</li>
<li>收到多数派响应代表读请求到达时还是leader，然后等待apply index大于等于commit index</li>
<li>返回结果</li></ol>
<p>etcd不仅实现了leader上的read only query，同时也实现了follower上的read only query，原理是一样的，只不过读请求到达follower时，commit index是需要向leader去要的，leader返回commit index给follower之前，同样，需要走上面的ReadIndex流程，因为leader同样需要check自己到底还是不是leader，代码不赘述。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j0ym0q.html">&lbrack;从产品角度学excel 04&rsqb;－单元格的&OpenCurlyDoubleQuote;衣服&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1664z8.html">Linux学习方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdepn3x9.html">oracle&lowbar;dblink配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xdp0e8.html">HDU 3695-Computer Virus on Planet Pandora（ac自动机）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydlwgdq.html">C&num;后台验证身份证号码的一个方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m1wn1q.html">ip、数字的互转</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgz2gr8.html">c&plus;&plus;，extern &OpenCurlyDoubleQuote;c&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pp7jy8.html">WPF动态加载3D&amp;nbsp&semi;放大-旋转-平移</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpojw39.html">scapy流量嗅探简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1vlgdq.html">sql 各种格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljo6ox9.html">Struts2&comma; jquery&comma; select二级联动</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd623d9.html">jquery基础总结 -- 转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw0dg79.html">用户端访问centos7上面的tomcat，访问页面出现的非常的慢？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyg60x9.html">解决angular ui-grid 中添加input date修改日期</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7omzng8.html">python自动生成bean类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwp3rv9.html">CentOS7&plus;CDH5&period;14&period;0安装CDH错误排查： HiveServer2 该角色的进程已退出。该角色的预期状态为已启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjp1d09.html">JVM虚拟机深入理解&plus;GC回收&plus;类加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjl6y79.html">自动化监控白皮书&mdash;&mdash;WAS监控</a>
		</li>
						<li><a href="https://www.batexi.com/a/960nwyv9.html">（1&period;12）SQL优化&mdash;&mdash;mysql表名、库名大小写敏感</a>
		</li>
						<li><a href="https://www.batexi.com/a/953nlne8.html">一个MMORPG的常规技能系统</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93yvllg8.html">javascript获取json对象的key名称的两种方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljk2gx9.html">C语言之运算符和条件结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/950wlmz8.html">springcloud&lpar;九&rpar;：配置中心和消息总线（配置中心终结版）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyj6lz9.html">OpenGL教程&lpar;1&rpar;&mdash;&mdash;准备</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpvzyr9.html">kotlin成长之路</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j2lew8.html">M41T11-RTC（实时时钟）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpve069.html">Javascript检测值</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjr2mr8.html">angular&period;js的ng-app 指令定义一个 AngularJS 应用程序。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjr3vy8.html">C&num;与Java对比学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg1vvr8.html">Java中Bean是什么</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
